/* $Id: rex_prot.x,v 1.2 1999/09/19 20:22:27 dm Exp $ */

/*
 * This file was written by David Mazieres.  Its contents is
 * uncopyrighted and in the public domain.  Of course, standards of
 * academic honesty nonetheless prevent anyone in research from
 * falsely claiming credit for this work.
 */

%#include "sfs_prot.h"

typedef string ttypath<63>;
typedef string utmphost<16>;

/* Note, a successful PTYD_PTY_ALLOC result is accompanied by a file
 * descriptor for the master side of the pty. */
union pty_alloc_res switch (int err) {
 case 0:
   ttypath path;
 default:
   void;
};

program PTYD_PROG {
	version PTYD_VERS {
		void
		PTYD_NULL (void) = 0;

		pty_alloc_res
		PTYD_PTY_ALLOC (utmphost) = 1;

		int
		PTYD_PTY_FREE (ttypath) = 2;
	} = 1;
} = 344431;

struct rex_payload {
  int channel;
  opaque data<>;
};

struct rex_mkchannel_arg {
  int channel;
  string command<>;
};

union rex_mkchannel_res switch (bool ok) {
 case TRUE:
   void;
 case FALSE:
   string error<>;
};

program REXCTL_PROG {
	version REXCTL_VERS {
		void REXCTL_NULL (void) = 0;
	} = 1;
} = 344424;

program REXD_PROG {
	version REXD_VERS {
		void
		REXD_KEYS (sfs_sessinfo) = 0;
	} = 1;
} = 344426;

program REX_PROG {
	version REX_VERS {
		void
		REX_NULL (void) = 0;

		void
		REX_DATA (rex_payload) = 1;

		rex_mkchannel_res
		REX_MKCHANNEL (rex_mkchannel_arg) = 2;
	} = 1;
} = 344428;

program REXCB_PROG {
	version REXCB_VERS {
		void
		REXCB_NULL (void) = 0;

		void
		REXCB_DATA (rex_payload) = 1;
	} = 1;
} = 344429;
